
use tempdb
go

-- if needed
IF OBJECTPROPERTY(object_id('invoice_docs'), 'IsUserTable') = 1
   DROP TABLE invoice_docs
go

-- if needed
-- DROP XML SCHEMA COLLECTION InvoiceType
-- go

-- Load XML from a file
DECLARE @x XML
SET @x = (
SELECT * FROM OPENROWSET(
   BULK 'C:\temp\invoice.xsd',
           SINGLE_BLOB
) AS x
)

-- And use it to create an XML schema collection
CREATE XML SCHEMA COLLECTION InvoiceType AS @x
go

CREATE TABLE invoice_docs (
 invoiceid INTEGER PRIMARY KEY IDENTITY,
 invoice   XML(document InvoiceType)
)
go


-- Insert an Invoice
INSERT INTO invoice_docs(invoice)
SELECT * FROM OPENROWSET(
   BULK 'C:\temp\invoice1.xml',
   SINGLE_BLOB) AS x
go

SELECT * FROM invoice_docs

-- Attempt to buy more than one product at a time
-- Fails
INSERT INTO invoice_docs(invoice)
SELECT * FROM OPENROWSET(
   BULK 'C:\temp\invoice2.xml',
   SINGLE_BLOB) AS x
go

-- Load the new XML schema from a file
DECLARE @x XML
SET @x = (
SELECT * FROM OPENROWSET(
   BULK 'C:\temp\invoice_v2.xsd',
           SINGLE_BLOB
) AS x
)

-- And use it to create an XML schema collection
-- Allow V1 and V2 invoices
ALTER XML SCHEMA COLLECTION InvoiceType ADD @x
go

-- Buy more than one product at a time
-- Include the required invoice date
INSERT INTO invoice_docs(invoice)
SELECT * FROM OPENROWSET(
   BULK 'C:\temp\invoice3.xml',
   SINGLE_BLOB) AS x
go

INSERT INTO invoice_docs(invoice)
SELECT * FROM OPENROWSET(
   BULK 'C:\temp\invoice4.xml',
   SINGLE_BLOB) AS x
go

-- "content" indicates fragments are allowed
ALTER TABLE invoice_docs 
  ALTER COLUMN invoice XML(content InvoiceType)
go

-- now the insert will work
INSERT INTO invoice_docs(invoice)
SELECT * FROM OPENROWSET(
   BULK 'C:\temp\invoice4.xml',
   SINGLE_BLOB) AS x
go

SELECT * FROM invoice_docs
go