create 

use xmltest
go

-- update when changed
update statistics xmlinvoice
dbcc freeproccache

-- PK - clustered index
-- TVF /Invoice
-- TVF /Invoice/InvoiceID
select * from xmlinvoice 
where invoice.exist('/Invoice[@InvoiceID = "1003"]') = 1

-- query plan change? yes 
-- PK - clustered index
-- TVF /Invoice/@InvoiceID
select * from xmlinvoice 
where invoice.exist('/Invoice/@InvoiceID[. = "1003"]') = 1

-- xml primary
create primary xml index invoiceidx ON xmlinvoice(invoice)

dbcc freeproccache

-- bottom up execution
-- execution starts with primary xml index

-- first scan on node table
-- then seek on base table
select *
from xmlinvoice
where invoice.exist('/Invoice/@InvoiceID[. = "1003"]') = 1


create xml index invpathidx on xmlinvoice(invoice)
 using xml index invoiceidx for path
dbcc freeproccache

-- top down execution
-- first scan on table for xml not null
-- now uses index seek on path
select *
from xmlinvoice
where invoice.exist('/Invoice/@InvoiceID[. = "1003"]') = 1


create xml index invvalidx on xmlinvoice(invoice)
 using xml index invoiceidx for value

create xml index invpropidx on xmlinvoice(invoice)
 using xml index invoiceidx for property

dbcc freeproccache

-- with all indexes defined
-- first scan on table for xml not null
-- still uses index seek on value
select *
from xmlinvoice
where invoice.exist('/Invoice/@InvoiceID[. = "1003"]') = 1